      subroutine filenames
      implicit none
C
C Cepos addition to MOPAC 6:
C
C Subroutine to define and open the input/output files
C
C These are:
C
C Channel 5:    <basename>(.dat)     :   input
C Channel 6:    <basename>.out       :   stdout
C Channel 9:    <basename>.res       :   restart file
C Channel 10:   <basename>.den       :   density matrix
C Channel 11:   <basename>.log       :   log file
C Channel 12:   <basename>.arc       :   archive file
C Channel 13:   <basename>.gpt       :   Data file for DENSITY
C Channel 15:   <basename>_esp.dump  :   ESP restart file
C Channel 16:   <basename>.syb       :   Sybyl data
C Channel 20:   <basename>.gau       :   Gaussian-tape input file
C Channel 21:   <basename>.pot       :   ESP potential file
C Channel 22:   <basename>_m.sdf     :   SDF file for ParaSurf input

C
C Cepos extension to assign file names
C
      common /files / file_names(22),namelen(22)

      character*80          file_names
      character*80          basename
      character*80          buffer
      character*3           inputfile
      integer               baselen, namelen, k
      logical               debug

      debug = .false.
C
C Construct the file names
C
      basename = file_names(1)
      baselen  = namelen(1)
      do k=1,baselen
         if(basename(k:k) .eq. "a") basename(k:k) = "A"
         if(basename(k:k) .eq. "b") basename(k:k) = "B"
         if(basename(k:k) .eq. "c") basename(k:k) = "C"
         if(basename(k:k) .eq. "d") basename(k:k) = "D"
         if(basename(k:k) .eq. "e") basename(k:k) = "E"
         if(basename(k:k) .eq. "f") basename(k:k) = "F"
         if(basename(k:k) .eq. "g") basename(k:k) = "G"
         if(basename(k:k) .eq. "h") basename(k:k) = "H"
         if(basename(k:k) .eq. "i") basename(k:k) = "I"
         if(basename(k:k) .eq. "j") basename(k:k) = "J"
         if(basename(k:k) .eq. "k") basename(k:k) = "K"
         if(basename(k:k) .eq. "l") basename(k:k) = "L"
         if(basename(k:k) .eq. "m") basename(k:k) = "M"
         if(basename(k:k) .eq. "n") basename(k:k) = "N"
         if(basename(k:k) .eq. "o") basename(k:k) = "O"
         if(basename(k:k) .eq. "p") basename(k:k) = "P"
         if(basename(k:k) .eq. "q") basename(k:k) = "Q"
         if(basename(k:k) .eq. "r") basename(k:k) = "R"
         if(basename(k:k) .eq. "s") basename(k:k) = "S"
         if(basename(k:k) .eq. "t") basename(k:k) = "T"
         if(basename(k:k) .eq. "u") basename(k:k) = "U"
         if(basename(k:k) .eq. "v") basename(k:k) = "V"
         if(basename(k:k) .eq. "w") basename(k:k) = "W"
         if(basename(k:k) .eq. "x") basename(k:k) = "X"
         if(basename(k:k) .eq. "y") basename(k:k) = "Y"
         if(basename(k:k) .eq. "z") basename(k:k) = "Z"
      enddo

      if(index(basename(1:baselen),".DAT") .ne.0) baselen = baselen - 4
      basename = file_names(1)
      basename(baselen+1:80) = "    "

      if(debug) write (6,'(" BASENAME is ",i4," characters long : ",a)') 
     &             baselen, basename(1:baselen)

      do k=2,22
        namelen(k) = 0
      enddo
C
C
C Input file name
C
      namelen(5) = namelen(1)
      file_names(5) = file_names(1)
      namelen(1) = 0
C
C Output file
C
      namelen(6) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".out"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(6) = buffer
      if(debug)write(6,'("Output file : ",a)')buffer(1:namelen(6))
C
C Restart file
C
      namelen(9) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".res"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(9) = buffer
      if(debug)write(6,'("Restart file : ",a)')buffer(1:namelen(9))
C
C Density file
C
      namelen(10) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".den"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(10) = buffer
      if(debug)write(6,'("Density file : ",a)')buffer(1:namelen(10))
C
C Log file
C
      namelen(11) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".log"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(11) = buffer
      if(debug)write(6,'("Log file : ",a)')buffer(1:namelen(11))
      
C
C Archive file
C
      namelen(12) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".arc"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(12) = buffer
      if(debug)write(6,'("Archive file : ",a)')buffer(1:namelen(12))
C
C GPT file (to run DENSITY)
C
      namelen(13) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".gpt"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(13) = buffer
      if(debug)write(6,'("GPT file : ",a)')buffer(1:namelen(13))
C
C ESP restart file
C
      namelen(15) = baselen + 9
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+9) = "_esp.dump"
      do k=baselen+10,80
         buffer(k:k) = " "
      enddo
      file_names(15) = buffer
      if(debug)write(6,'("ESP restart file : ",a)')buffer(1:namelen(15))
      
C
C Sybyl file
C
      namelen(16) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".syb"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(16) = buffer
      if(debug)write(6,'("Sybyl file : ",a)')buffer(1:namelen(16))
C
C Gaussian file
C
      namelen(20) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".gau"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(20) = buffer
      if(debug)write(6,'("Gaussian file : ",a)')buffer(1:namelen(20))
      
C
C Potentials file
C
      namelen(21) = baselen + 4
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+4) = ".pot"
      do k=baselen+5,80
         buffer(k:k) = " "
      enddo
      file_names(21) = buffer
      if(debug)write(6,'("Potentials file : ",a)')buffer(1:namelen(21))
      
C
C SDF file for ParaSurf
C
      namelen(22) = baselen + 6
      buffer(1:baselen) = basename
      buffer(baselen+1:baselen+6) = "_m.sdf"
      do k=baselen+7,80
         buffer(k:k) = " "
      enddo
      file_names(22) = buffer
      if(debug)write(6,'("SDF file : ",a)')buffer(1:namelen(22))
      
      end 
