      SUBROUTINE TRED2(A,N,NP,D,E)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(NP,NP),D(NP),E(NP)
      DO 18 I=N,2,-1
        L=I-1
        H=0.
        SCALE=0.
        IF(L.GT.1)THEN
          DO 11 K=1,L
            SCALE=SCALE+ABS(A(I,K))
11        CONTINUE
          IF(SCALE.EQ.0.)THEN
            E(I)=A(I,L)
          ELSE
            DO 12 K=1,L
              A(I,K)=A(I,K)/SCALE
              H=H+A(I,K)**2
12          CONTINUE
            F=A(I,L)
            G=-SIGN(SQRT(H),F)
            E(I)=SCALE*G
            H=H-F*G
            A(I,L)=F-G
            F=0.
            DO 15 J=1,L
C     Omit following line if finding only eigenvalues
              A(J,I)=A(I,J)/H
              G=0.
              DO 13 K=1,J
                G=G+A(J,K)*A(I,K)
13            CONTINUE
              DO 14 K=J+1,L
                G=G+A(K,J)*A(I,K)
14            CONTINUE
              E(J)=G/H
              F=F+E(J)*A(I,J)
15          CONTINUE
            HH=F/(H+H)
            DO 17 J=1,L
              F=A(I,J)
              G=E(J)-HH*F
              E(J)=G
              DO 16 K=1,J
                A(J,K)=A(J,K)-F*E(K)-G*A(I,K)
16            CONTINUE
17          CONTINUE
          ENDIF
        ELSE
          E(I)=A(I,L)
        ENDIF
        D(I)=H
18    CONTINUE
C     Omit following line if finding only eigenvalues.
      D(1)=0.
      E(1)=0.
      DO 23 I=1,N
C     Delete lines from here ...
        L=I-1
        IF(D(I).NE.0.)THEN
          DO 21 J=1,L
            G=0.
            DO 19 K=1,L
              G=G+A(I,K)*A(K,J)
19          CONTINUE
            DO 20 K=1,L
              A(K,J)=A(K,J)-G*A(K,I)
20          CONTINUE
21        CONTINUE
        ENDIF
C     ... to here when finding only eigenvalues.
        D(I)=A(I,I)
C     Also delete lines from here ...
        A(I,I)=1.
        DO 22 J=1,L
          A(I,J)=0.
          A(J,I)=0.
22      CONTINUE
C     ... to here when finding only eigenvalues.
23    CONTINUE
      RETURN
      END
C ---------------------------------------------------------------------
      SUBROUTINE TQLI(D,E,N,NP,Z)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION D(NP),E(NP),Z(NP,NP)
      DO 11 I=2,N
        E(I-1)=E(I)
11    CONTINUE
      E(N)=0.
      DO 15 L=1,N
        ITER=0
1       DO 12 M=L,N-1
          DD=ABS(D(M))+ABS(D(M+1))
          IF (ABS(E(M))+DD.EQ.DD) GO TO 2
12      CONTINUE
        M=N
2       IF(M.NE.L)THEN
          IF(ITER.EQ.30)PAUSE 'too many iterations'
          ITER=ITER+1
          G=(D(L+1)-D(L))/(2.*E(L))
          R=SQRT(G**2+1.)
          G=D(M)-D(L)+E(L)/(G+SIGN(R,G))
          S=1.
          C=1.
          P=0.
          DO 14 I=M-1,L,-1
            F=S*E(I)
            B=C*E(I)
            IF(ABS(F).GE.ABS(G))THEN
              C=G/F
              R=SQRT(C**2+1.)
              E(I+1)=F*R
              S=1./R
              C=C*S
            ELSE
              S=F/G
              R=SQRT(S**2+1.)
              E(I+1)=G*R
              C=1./R
              S=S*C
            ENDIF
            G=D(I+1)-P
            R=(D(I)-G)*S+2.*C*B
            P=S*R
            D(I+1)=G+P
            G=C*R-B
C     Omit lines from here ...
            DO 13 K=1,N
              F=Z(K,I+1)
              Z(K,I+1)=S*Z(K,I)+C*F
              Z(K,I)=C*Z(K,I)-S*F
13          CONTINUE
C     ... to here when finding only eigenvalues.
14        CONTINUE
          D(L)=D(L)-P
          E(L)=G
          E(M)=0.
          GO TO 1
        ENDIF
15    CONTINUE
      RETURN
      END
C ---------------------------------------------------------------------
      SUBROUTINE EIGSRT(D,V,N,NP)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION D(NP),V(NP,NP)
      DO 13 I=1,N-1
        K=I
        P=D(I)
        DO 11 J=I+1,N
          IF(D(J).LE.P)THEN
            K=J
            P=D(J)
          ENDIF
11      CONTINUE
        IF(K.NE.I)THEN
          D(K)=D(I)
          D(I)=P
          DO 12 J=1,N
            P=V(J,I)
            V(J,I)=V(J,K)
            V(J,K)=P
12        CONTINUE
        ENDIF
13    CONTINUE
      RETURN
      END
C ---------------------------------------------------------------------
      SUBROUTINE QTOU(Q,U)
      IMPLICIT REAL*8 (A-H,O-Z)

      DIMENSION Q(4),U(3,3)

      data a2 / 2.d+00 /
      
      A=Q(1)
      B=Q(2)
      C=Q(3)
      D=Q(4)

      U(1,1) = A*A + B*B - C*C - D*D
      U(1,2) = A2*(B*C - A*D)
      U(1,3) = A2*(B*D + A*C)

      U(2,1) = A2*(B*C + A*D)
      U(2,2) = A*A - B*B + C*C - D*D
      U(2,3) = A2*(C*D - A*B)

      U(3,1) = A2*(B*D - A*C)
      U(3,2) = A2*(C*D + A*B)
      U(3,3) = A*A - B*B - C*C + D*D

      RETURN
      END
C ---------------------------------------------------------------------
      SUBROUTINE SUPIMP(AAA,BBB,N,U,T)
      IMPLICIT REAL*8 (A-H,O-Z)
C ---------------------------------------------------------------------
C     DETERMINE THE ROTATION U AND TRANSLATION T NEEDED TO SUPERIMPOSE
C     A SET OF N COORDINATES AAA WITH ANOTHER SET OF N COORDINATES BBB
C     THE ORDER OF COORDINATES IS ASSUMED TO BE THE SAME
C     ALGORITHM : REPRESENT U BY A QUATERNION Q, OPTIMIZE Q.
C ---------------------------------------------------------------------
      DIMENSION AAA(3,N),BBB(3,N),U(3,3),T(3)

      DIMENSION AAACOM(3),BBBCOM(3)
      DIMENSION A(3),B(3)
      DIMENSION D(4),E(4),Q(4)
      DIMENSION XYZ(3)
      DIMENSION C(4,4) 
      DIMENSION CCHECK(4,4) 
      dimension x(4)

      DO 10 I=1,3
         AAACOM(I)=0.D+00
         BBBCOM(I)=0.D+00
   10    CONTINUE

      DO 20 I=1,N
         AAACOM(1) = AAACOM(1) + AAA(1,I)
         AAACOM(2) = AAACOM(2) + AAA(2,I)
         AAACOM(3) = AAACOM(3) + AAA(3,I)
         BBBCOM(1) = BBBCOM(1) + BBB(1,I)
         BBBCOM(2) = BBBCOM(2) + BBB(2,I)
         BBBCOM(3) = BBBCOM(3) + BBB(3,I)
   20    CONTINUE

      DO 30 I=1,3
         AAACOM(I)=AAACOM(I)/DBLE(N)
         BBBCOM(I)=BBBCOM(I)/DBLE(N)
   30    CONTINUE

      XXYX=0.D+00
      XXYY=0.D+00
      XXYZ=0.D+00
      XYYX=0.D+00
      XYYY=0.D+00
      XYYZ=0.D+00
      XZYX=0.D+00
      XZYY=0.D+00
      XZYZ=0.D+00

      DO 40 I=1,N
         A(1)=AAA(1,I)-AAACOM(1)
         A(2)=AAA(2,I)-AAACOM(2)
         A(3)=AAA(3,I)-AAACOM(3)
         B(1)=BBB(1,I)-BBBCOM(1)
         B(2)=BBB(2,I)-BBBCOM(2)
         B(3)=BBB(3,I)-BBBCOM(3)
         XXYX = XXYX + A(1)*B(1)
         XXYY = XXYY + A(1)*B(2)
         XXYZ = XXYZ + A(1)*B(3)
         XYYX = XYYX + A(2)*B(1)
         XYYY = XYYY + A(2)*B(2)
         XYYZ = XYYZ + A(2)*B(3)
         XZYX = XZYX + A(3)*B(1)
         XZYY = XZYY + A(3)*B(2)
         XZYZ = XZYZ + A(3)*B(3)
   40    CONTINUE

      C(1,1) = XXYX + XYYY + XZYZ
      C(1,2) = XZYY - XYYZ
      C(2,1) = C(1,2)
      C(2,2) = XXYX - XYYY - XZYZ
      C(1,3) = XXYZ - XZYX
      C(3,1) = C(1,3)
      C(2,3) = XXYY + XYYX
      C(3,2) = C(2,3)
      C(3,3) = XYYY - XZYZ - XXYX
      C(1,4) = XYYX - XXYY
      C(4,1) = C(1,4)
      C(2,4) = XZYX + XXYZ
      C(4,2) = C(2,4)
      C(3,4) = XYYZ + XZYY
      C(4,3) = C(3,4)
      C(4,4) = XZYZ - XXYX - XYYY

      CALL TRED2(C,4,4,D,E)
      CALL TQLI(D,E,4,4,C)
      CALL EIGSRT(D,C,4,4)

      DO 50 I=1,4
         Q(I) = C(I,4)
   50    CONTINUE

      CALL QTOU(Q,U)

      DO 60 I=1,3
         T(I) = BBBCOM(I) - ( U(1,I)*AAACOM(1) +
     1                        U(2,I)*AAACOM(2) +
     2                        U(3,I)*AAACOM(3) )
   60    CONTINUE

      RMSDEV=0.D+00
      DO 70 I=1,N
         DO 80 J=1,3
            XYZ(J) = U(1,J)*AAA(1,I) +
     1               U(2,J)*AAA(2,I) +
     2               U(3,J)*AAA(3,I) + T(J)
   80       CONTINUE
         DO 90 J=1,3
            XYZ(J) = XYZ(J) - BBB(J,I)
   90       CONTINUE
         RMSDEV = RMSDEV +
     1            XYZ(1)*XYZ(1) + XYZ(2)*XYZ(2) + XYZ(3)*XYZ(3)
   70    CONTINUE

      RMSDEV = SQRT(RMSDEV/DBLE(N))
      WRITE(6,601) RMSDEV
  601 FORMAT(/,' RMS DEVIATION = ',F14.8)

      RETURN
      END
